searchNodes=[{"ref":"Xalsa.html","title":"Xalsa","type":"module","doc":"Elixir ALSA connector. The Xalsa module implements the API. The client may send any number of frames as a binary array of 32 bit floats and may optionally receive back a notification in form of a :ready4more message 5-10 ms before all frames are consumed by the ALSA driver. The :xalsa application needs to be started before calling the API. Also check the config/config.exs file on how to configure PCM devices for xalsa."},{"ref":"Xalsa.html#clear_max_mix_time/0","title":"Xalsa.clear_max_mix_time/0","type":"function","doc":"Reset the max prepare time gauges to 0"},{"ref":"Xalsa.html#float_list_to_binary/1","title":"Xalsa.float_list_to_binary/1","type":"function","doc":"Convert a list of (Erlang) floats to a binary of 32 bit (C) floats"},{"ref":"Xalsa.html#flush_ready4more/0","title":"Xalsa.flush_ready4more/0","type":"function","doc":"Flush any :ready4more messages from the xalsa server in input queue. Returns true if there were any."},{"ref":"Xalsa.html#max_mix_time/0","title":"Xalsa.max_mix_time/0","type":"function","doc":"The maximum buffer prepare time in µs, for all started pcm cards, since application start or last reset. Examples iex&gt; Xalsa.max_mix_time() [254]"},{"ref":"Xalsa.html#no_of_channels/0","title":"Xalsa.no_of_channels/0","type":"function","doc":"Total number of channels for all PCM devices together."},{"ref":"Xalsa.html#pcms/0","title":"Xalsa.pcms/0","type":"function","doc":"Lists the PCM names and their number of channels respectively. Example iex&gt; Xalsa.pcms() [&quot;plughw:1,0&quot;: 2]"},{"ref":"Xalsa.html#period_size/0","title":"Xalsa.period_size/0","type":"function","doc":"Return the number of frames that the ALSA driver consumes per callback cycle."},{"ref":"Xalsa.html#rate/0","title":"Xalsa.rate/0","type":"function","doc":"The sample rate, number of frames per second"},{"ref":"Xalsa.html#send_frames/4","title":"Xalsa.send_frames/4","type":"function","doc":"Send frames in a binary array of frame:32/float-native. If the notify flag is true a :ready4more message will be sent to the process in the from argument when the process frames are due to be consumed within 5-10 ms. This so that the process may synthesize/produce more frames."},{"ref":"Xalsa.html#wait_ready4more/0","title":"Xalsa.wait_ready4more/0","type":"function","doc":"The client will wait until :ready4more notification is sent from xalsa server."},{"ref":"Xalsa.html#t:rates/0","title":"Xalsa.rates/0","type":"type","doc":"The sample rate is set in the application environment (config file for the application)."},{"ref":"readme.html","title":"Xalsa","type":"extras","doc":"Xalsa Elixir ALSA Connector Actually most code is (currently) in Erlang but with an API in Elixir as frontend. ALSA stands for Advanced Linux Sound Architecture. Xalsa uses NIFs to connect to the ALSA library. The idea is to create some base for experimenting with sound synthesis in Elixir/Erlang using the process concept as central part in the architecture."},{"ref":"readme.html#what-it-is","title":"Xalsa - What it is","type":"extras","doc":"Sound card drivers are configured to do asynchronous calls around every 5 ms to the xalsa_server process which delivers the number of frames (PCM samples) to the device driver to keep the card busy for yet another round of 5 ms. The frames are sent to a ring buffer made of two frame buffers. While one is used for generating audio the other is filled from the xalsa server. The xalsa_server queues samples on a per channel and process id basis, meaning that sample frames sent from one process to a specific channel will be queued behind existing frames from the same process if they exist (not yet consumed by the audio driver). Frames from other processes will be put in their own queue. Frames from the different queues will be mixed before delivered to the driver. This means every process may synthesize and sequence their own tone(s) independently. The frames are to be in a binary array of 32 bit floats for the C api. The Xalsa module holds a helper function to convert from an Elixir list of floats."},{"ref":"readme.html#installation","title":"Xalsa - Installation","type":"extras","doc":"Currently checkout from github. mix deps.get mix compile. In order to compile the c code you will need some alsa development libraries to be installed (libasound2-dev). If using from own application, append line: {:xalsa, &quot;~&gt; 0.1.0&quot;} to your dependency list."},{"ref":"readme.html#configuration","title":"Xalsa - Configuration","type":"extras","doc":"The config/config.exs file has comments on how to configure your PCM devices, which can be a bit tricky. Default setting of application environment is in mix.exs."},{"ref":"readme.html#running","title":"Xalsa - Running","type":"extras","doc":"mix test Application.start(:xalsa) from your own application. Check the test/xalsa_test.exs script for an example. or iex -S mix"}]